diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
new file mode 100644
index 000000000..70f190ca4
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
@@ -0,0 +1,233 @@
+package net.minecraft.client.render.tessellator;
+
+import java.nio.ByteBuffer;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.terrain.VertexConfig;
+import net.minecraft.client.render.terrain.VertexData;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
+
+public class TessellatorTerrainImpl implements TessellatorTerrain {
+	private static final Logger LOGGER = LogUtils.getLogger();
+	public TerrainVertexData data;
+	public boolean drawing;
+
+	private int color;
+	private int lightmapCoord;
+	
+	private double textureU;
+	private double textureV;
+	
+	private double offsetX;
+	private double offsetY;
+	private double offsetZ;
+
+	private boolean lockedColor = false;
+	private int quadVertCount = 0;
+	
+	public TessellatorTerrainImpl(int bufferSize) {
+        this.data = new TerrainVertexData(bufferSize);
+	}
+	
+	@Override
+	public void startDrawing(@NotNull DrawMode drawMode) {
+		if(this.drawing) {
+			this.drawing = false;
+			throw new IllegalStateException("Already drawing!");
+		}
+
+		this.drawing = true;
+        this.data.vertexCount = 0;
+		this.quadVertCount = 0;
+
+		setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
+		setColor4i(255, 255, 255, 255);
+		setTextureUV(0.0, 0.0);
+
+		this.lockedColor = false;
+        this.data.buffer.clear();
+	}
+
+	@Override
+	public void draw() {
+		throw new UnsupportedOperationException();
+	}
+
+	@Override
+	public @NotNull RenderBuffer record(int vao, int vbo) {
+		throw new UnsupportedOperationException();
+	}
+
+	@Override
+	public void addVertex(double x, double y, double z) {
+		checkIsDrawing();
+		checkCanFit(64);
+		
+		ByteBuffer buffer = this.data.buffer;
+		
+		buffer.putFloat((float) (this.offsetX + x));
+		buffer.putFloat((float) (this.offsetY + y));
+		buffer.putFloat((float) (this.offsetZ + z));
+
+        buffer.putInt(this.color);
+
+        buffer.putFloat((float) this.textureU);
+        buffer.putFloat((float) this.textureV);
+
+        buffer
+            .put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmapCoord) << 4) + 7))
+            .put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmapCoord) << 4) + 7));
+
+
+        this.data.vertexCount++;
+
+		if (Tessellator.QUAD_EMULATION && this.quadVertCount % 4 == 2) {
+			int vertSize = this.data.config.getVertexSize();
+
+			checkCanFit(128);
+			this.data.buffer.put(this.data.buffer.position(), this.data.buffer, this.data.buffer.position() - vertSize * 3, vertSize);
+			this.data.buffer.put(this.data.buffer.position() + vertSize, this.data.buffer, this.data.buffer.position() - vertSize, vertSize);
+			this.data.buffer.position(this.data.buffer.position() + vertSize * 2);
+			this.data.vertexCount += 2;
+		}
+
+		this.quadVertCount++;
+	}
+
+	public void checkCanFit(int size) {
+		if(this.data.buffer.capacity() < this.data.buffer.position() + size) {
+			int newSize = this.data.buffer.capacity() * 2;
+
+			LOGGER.info("Expanding {} Buffer ({} -> {})", "Entity Tessellator", this.data.buffer.capacity(), newSize);
+
+			ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
+			this.data.buffer.flip();
+			newBuffer.put(this.data.buffer);
+			this.data.buffer = newBuffer;
+		}
+	}
+
+	@Override
+	public void setTextureUV(double u, double v) {
+		checkIsDrawing();
+
+		this.textureU = u;
+		this.textureV = v;
+	}
+
+	@Override
+	public void setLightmapCoord1i(int lightmapCoord) {
+		checkIsDrawing();
+
+		this.lightmapCoord = lightmapCoord;
+	}
+
+	@Override
+	public void setColor1i(int argb) {
+		checkIsDrawing();
+		if (this.lockedColor) {
+			return;
+		}
+
+		int a = (argb >> 24) & 0xFF;
+		int r = (argb >> 16) & 0xFF;
+		int g = (argb >> 8) & 0xFF;
+		int b = argb & 0xFF;
+
+		this.color = a << 24 | b << 16 | g << 8 | r;
+	}
+
+	@Override
+	public void lockColor() {
+		checkIsDrawing();
+		
+		this.lockedColor = true;
+	}
+
+	@Override
+	public void setTranslation(double x, double y, double z) {
+		this.offsetX = x;
+		this.offsetY = y;
+		this.offsetZ = z;
+	}
+
+	@Override
+	public void offsetTranslation(double x, double y, double z) {
+		this.offsetX += x;
+		this.offsetY += y;
+		this.offsetZ += z;
+	}
+
+	public void checkIsDrawing() {
+		if(!this.drawing) {
+			throw new IllegalStateException("Not drawing!");
+		}
+	}
+
+	public static class TerrainVertexData extends VertexData {
+
+		public TerrainVertexData(int size) {
+			super(size);
+			this.config = new TerrainVertexConfig();
+		}
+	}
+
+	public static class TerrainVertexConfig implements VertexConfig<TerrainVertexConfig> {
+
+		@Override
+		public @NotNull DrawMode drawmode() {
+			return Tessellator.QUAD_EMULATION ? DrawMode.TRIANGLES : DrawMode.QUADS;
+		}
+
+		public void enable(int vao, int vbo) {
+			GL41.glBindVertexArray(vao);
+			GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+			int vertexSize = getVertexSize();
+			int offset = 0;
+			GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
+            GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 4;    // Color
+			GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
+			GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;    // Lightmap
+
+			GL41.glEnableVertexAttribArray(0);
+			GL41.glEnableVertexAttribArray(1);
+			GL41.glEnableVertexAttribArray(2);
+			GL41.glEnableVertexAttribArray(3);
+
+			GL41.glVertexAttrib3f(4, 0, -1, 0);
+		}
+
+		public void disable() {
+			GL41.glDisableVertexAttribArray(0);
+			GL41.glDisableVertexAttribArray(1);
+			GL41.glDisableVertexAttribArray(2);
+			GL41.glDisableVertexAttribArray(3);
+
+			GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
+			GL41.glBindVertexArray(0);
+		}
+
+		public int getVertexSize() {
+			int size = Float.BYTES * 3;
+            size += 4;
+            size += Float.BYTES * 2;
+            size += 2;
+			return size;
+		}
+
+		public @NotNull TerrainVertexConfig copy() {
+            return this;
+		}
+
+		@Override
+		public boolean equals(Object obj) {
+            return obj instanceof TerrainVertexConfig;
+        }
+	}
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTextured.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTextured.java
new file mode 100644
index 000000000..90a2348c4
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTextured.java
@@ -0,0 +1,17 @@
+package net.minecraft.client.render.tessellator;
+
+public interface TessellatorTextured extends Tessellator {
+    void setTextureUV(double u, double v);
+
+    default void addVertexWithUV(double x, double y, double z, double u, double v) {
+        setTextureUV(u, v);
+        addVertex(x, y, z);
+    }
+
+    default void drawRectangleWithUV(int x, int y, int width, int height, double u, double v, double uvWidth, double uvHeight) {
+        this.addVertexWithUV(x, y, 0.0D, u, v);
+        this.addVertexWithUV(x, y + height, 0.0D, u, v + uvHeight);
+        this.addVertexWithUV(x + width, y + height, 0.0D, u + uvWidth, v + uvHeight);
+        this.addVertexWithUV(x + width, y, 0.0D, u + uvWidth, v);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
index 308593ce1..40c29ed80 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.texture;
 
 import static net.minecraft.core.util.helper.Buffer.buffer;
 import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL12.GL_CLAMP_TO_EDGE;
 import static org.lwjgl.opengl.GL12.GL_TEXTURE_MAX_LEVEL;
 
 import com.mojang.logging.LogUtils;
@@ -125,8 +126,8 @@ public class Texture {
 		}
 
 		if(clampTexture) {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
 		}else {
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index bdc586798..1b7b5f9c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -3,11 +3,11 @@ package net.minecraft.client.render.texture.stitcher;
 import java.awt.AlphaComposite;
 import java.awt.Graphics2D;
 import java.awt.image.BufferedImage;
-import java.io.File;
+import java.io.IOException;
 import java.io.InputStream;
+import java.net.URISyntaxException;
 import java.util.ArrayList;
 import java.util.Collections;
-import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 import java.util.concurrent.Callable;
@@ -17,9 +17,11 @@ import java.util.concurrent.Executors;
 import java.util.concurrent.Future;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texturepack.TexturePack;
+import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -31,46 +33,68 @@ import org.slf4j.Logger;
 public class AtlasStitcher extends Texture {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final String rootAssetPath = "/assets";
-    public Map<NamespaceID, IconCoordinate> textureMap = new HashMap<>();
+    public @NotNull Map<NamespaceID, IconCoordinate> textureMap = new Object2ObjectOpenHashMap<>();
+    public @NotNull Map<String, String> idDirMap = new Object2ObjectOpenHashMap<>();
+    public final @Nullable BufferedImage defaultTexture;
     public BufferedImage atlas;
-    public final String directoryPath;
-    @Nullable
-    public final String defaultTexture;
     private int atlasWidth;
     private int atlasHeight;
     private double invWidth;
     private double invHeight;
     private final boolean mipmap;
     private final boolean tickPaused;
-    public AtlasStitcher(String directoryPath, boolean tickWhenPaused, boolean mipmap, @Nullable String defaultTexture){
-        this.directoryPath = directoryPath;
+    public AtlasStitcher(boolean tickWhenPaused, boolean mipmap, @Nullable BufferedImage defaultTexture){
         this.tickPaused = tickWhenPaused;
         this.mipmap = mipmap;
         this.defaultTexture = defaultTexture;
     }
 
-    protected @NotNull IconCoordinate getTexture(@NotNull NamespaceID sourceId, @NotNull NamespaceID id){
-        IconCoordinate cached = textureMap.get(id); // Changed to read cached value this way as somehow this method previously managed to return null https://bugs.betterthanadventure.net/scp/tickets.php?id=246
+    public @NotNull AtlasStitcher addDirectory(@NotNull String id, @NotNull String path) {
+        this.idDirMap.put(id, path);
+        return this;
+    }
+
+    protected @NotNull IconCoordinate getTexture(@NotNull NamespaceID id){
+        IconCoordinate cached = this.textureMap.get(id); // Changed to read cached value this way as somehow this method previously managed to return null https://bugs.betterthanadventure.net/scp/tickets.php?id=246
         if (cached != null) return cached;
 
-        id.makePermanent();
-        IconCoordinate iconCoordinate = new IconCoordinate(this, sourceId.makePermanent(), id, getSourceImagePath(id));
-        textureMap.put(id, iconCoordinate);
+        IconCoordinate iconCoordinate = new IconCoordinate(this, id, getSourceImagePath(id));
+        this.textureMap.put(id, iconCoordinate);
         return iconCoordinate;
     }
-    public String getSourceImagePath(@NotNull NamespaceID id){
-        return String.format("%s/%s/%s/%s.png", rootAssetPath, id.namespace(), directoryPath, id.value());
+
+    public @NotNull String getSourceImagePath(@NotNull NamespaceID id){
+        String value = id.value();
+        int slashIndex = value.indexOf("/");
+        if (slashIndex != -1) {
+            String dir = this.idDirMap.get(value.substring(0, slashIndex));
+            return String.format("%s/%s/%s/%s.png", rootAssetPath, id.namespace(), dir, value.substring(slashIndex + 1));
+        } else {
+            throw new IllegalArgumentException("Id " + id + " does not specify an id!");
+        }
+    }
+
+    public void initializeAll(@NotNull String namespace, boolean searchSubDirectories) throws IOException, URISyntaxException {
+        for (Map.Entry<String, String> e : this.idDirMap.entrySet()) {
+            String folder = String.format("%s/%s/%s/", rootAssetPath, namespace, e.getValue());
+
+            String[] paths = TextureRegistry.getFilesAndSubFiles(folder, searchSubDirectories);
+
+            for (String p : paths) {
+                getTexture(new NamespaceID(namespace, e.getKey() + "/" + p.replace(".png", "")));
+            }
+        }
     }
 
     public void preinit() {
         generate();
         long startTime = System.nanoTime();
         Minecraft mc = Minecraft.getMinecraft();
-        List<IconCoordinate> coordinateList = new ArrayList<>(textureMap.values());
+        List<IconCoordinate> coordinateList = new ArrayList<>(this.textureMap.values());
         List<Future<?>> futures = new ArrayList<>();
         ExecutorService service = Executors.newFixedThreadPool(32);
         for (IconCoordinate coordinate : coordinateList){
-            futures.add(service.submit(new SetupTexture(mc, coordinate, defaultTexture)));
+            futures.add(service.submit(new SetupTexture(mc.texturePackList, coordinate, this.defaultTexture)));
         }
 
         for (Future<?> f : futures) {
@@ -89,7 +113,7 @@ public class AtlasStitcher extends Texture {
         // Load all individual textures and the store the widths
         int area = 0;
         int maxWidth = 0;
-        List<IconCoordinate> coordinateList = new ArrayList<>(textureMap.values());
+        List<IconCoordinate> coordinateList = new ArrayList<>(this.textureMap.values());
         for (IconCoordinate coordinate : coordinateList){
             if (coordinate.needsDimensions()) {
                 BufferedImage image = coordinate.getImageStorage();
@@ -121,11 +145,10 @@ public class AtlasStitcher extends Texture {
         // Generate and then copy the data to a new image with the dimensions needed
         BufferedImage generatedAtlas = new BufferedImage(targetWidth, Integer.highestOneBit(nextY) << 1, BufferedImage.TYPE_INT_ARGB);
 
-        atlasWidth = generatedAtlas.getWidth();
-        atlasHeight = generatedAtlas.getHeight();
-        invWidth = 1d/atlasWidth;
-        invHeight = 1d/atlasHeight;
-        this.atlas = generatedAtlas;
+        this.atlasWidth = generatedAtlas.getWidth();
+        this.atlasHeight = generatedAtlas.getHeight();
+        this.invWidth = 1d/ this.atlasWidth;
+        this.invHeight = 1d/ this.atlasHeight;
 
         Graphics2D atlas = generatedAtlas.createGraphics();
         atlas.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f));
@@ -135,68 +158,69 @@ public class AtlasStitcher extends Texture {
         }
         atlas.dispose();
 
-        setupTexture(this.atlas, false, false, mipmap);
+        setupTexture(generatedAtlas, false, false, this.mipmap);
+
+        this.atlas = generatedAtlas;
     }
 
     public int getAtlasWidth(){
-        return atlasWidth;
+        return this.atlasWidth;
     }
     public int getAtlasHeight(){
-        return atlasHeight;
+        return this.atlasHeight;
     }
     public double getInverseWidth(){
-        return invWidth;
+        return this.invWidth;
     }
     public double getInverseHeight(){
-        return invHeight;
+        return this.invHeight;
     }
-    public boolean tickWhenPaused() {return tickPaused;}
-    public boolean hasMipmaps() {return mipmap;}
+    public boolean tickWhenPaused() {return this.tickPaused;}
+    public boolean hasMipmaps() {return this.mipmap;}
 
     public static class SetupTexture implements Callable<IconCoordinate> {
-        private final Minecraft mc;
-        private final IconCoordinate coordinate;
-        private final String defaultTexture;
-        public SetupTexture(Minecraft mc, IconCoordinate coordinate, String defaultTexture) {
-            this.mc = mc;
+        private final @NotNull TexturePackList packList;
+        private final @NotNull IconCoordinate coordinate;
+        private final @Nullable BufferedImage defaultTexture;
+        public SetupTexture(@NotNull TexturePackList packList, @NotNull IconCoordinate coordinate, @Nullable BufferedImage defaultTexture) {
+            this.packList = packList;
             this.coordinate = coordinate;
             this.defaultTexture = defaultTexture;
         }
         @Override
         public IconCoordinate call() {
-            coordinate.resetMetadata();
-            BufferedImage image = CustomAtlasHandler.getTextureOverride(mc.texturePackList, coordinate.sourceImage);
+            this.coordinate.resetMetadata();
+            BufferedImage image = CustomAtlasHandler.getTextureOverride(this.packList, this.coordinate.sourceImagePath);
             if(image == null) {
-                TexturePack pack = mc.texturePackList.getHighestPriorityTexturePackWithFile(coordinate.sourceImage);
+                TexturePack pack = this.packList.getHighestPriorityTexturePackWithFile(this.coordinate.sourceImagePath);
                 if (pack != null) {
                     for (int attempt = 0; attempt < 3; attempt++) {
                         try {
-                            image = Textures.readImageUnhandled(pack.getResourceAsStream(coordinate.sourceImage));
+                            image = Textures.readImageUnhandled(pack.getResourceAsStream(this.coordinate.sourceImagePath));
                             if (image != null) break;
                         } catch (Exception e) {
                             LOGGER.error("", e);
                         }
                     }
-                    String metaPath = coordinate.sourceImage + ".mcmeta";
+                    String metaPath = this.coordinate.sourceImagePath + ".mcmeta";
                     if (pack.hasFile(metaPath)) {
                         try (InputStream stream = pack.getResourceAsStream(metaPath)){
-                            coordinate.initMetadata(stream);
+                            this.coordinate.initMetadata(stream);
                         } catch (Exception e) {
-                            LOGGER.error("Failed to initiate metadata for '{}'!", coordinate.namespaceId, e);
+                            LOGGER.error("Failed to initiate metadata for '{}'!", this.coordinate.namespaceId, e);
                         }
                     }
                 }
-
             }
             if (image == null || image == Textures.missingTexture){
-                LOGGER.warn("{} could not be found!", coordinate.sourceImage);
-                if (defaultTexture != null){
-                    image = Textures.readImage(mc.texturePackList.getResourceAsStream(defaultTexture));
+                LOGGER.warn("{} could not be found!", this.coordinate.sourceImagePath);
+                if (this.defaultTexture != null){
+                    image = this.defaultTexture;
                 }
                 if (image == null) image = Textures.missingTexture; // If this ever happens I'll be very sad
             }
-            coordinate.setImage(image);
-            return coordinate;
+            this.coordinate.setImage(image);
+            return this.coordinate;
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
index 22f1800b3..ccf2bee8b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
@@ -24,18 +24,16 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     private double uSize;
     private double vSize;
     private boolean pendingDimensions;
-    protected final String sourceImage;
-    protected final TextureMetaHandler metaHandler = new TextureMetaHandler();
-    public final NamespaceID namespaceId;
-    public final NamespaceID sourceNamespaceId;
-    public final AtlasStitcher parentAtlas;
+    protected final @NotNull String sourceImagePath;
+    protected final @NotNull TextureMetaHandler metaHandler = new TextureMetaHandler();
+    public final @NotNull NamespaceID namespaceId;
+    public final @NotNull AtlasStitcher parentAtlas;
     private BufferedImage _imageStorage;
 
-    public IconCoordinate(AtlasStitcher stitcher, NamespaceID sourceNamespaceId, NamespaceID namespaceId, String sourceImage) {
+    public IconCoordinate(@NotNull AtlasStitcher stitcher, @NotNull NamespaceID namespaceId, @NotNull String sourceImagePath) {
         this.parentAtlas = stitcher;
-        this.sourceNamespaceId = sourceNamespaceId;
         this.namespaceId = namespaceId;
-        this.sourceImage = sourceImage;
+        this.sourceImagePath = sourceImagePath;
     }
 
     protected void setImage(@NotNull BufferedImage image) {
@@ -81,7 +79,7 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     }
 
     protected void drawToAtlas(Graphics2D atlas) {
-        assert this._imageStorage != null : "Image storage should not be null!! something went wrong with image '" + this.namespaceId + "' at '" + this.sourceImage + "'!";
+        assert this._imageStorage != null : "Image storage should not be null!! something went wrong with image '" + this.namespaceId + "' at '" + this.sourceImagePath + "'!";
         if (this.width != this._imageStorage.getWidth() || this.height != this._imageStorage.getHeight()) {
             int[] subImage = this._imageStorage.getRGB(0, 0, this.width, this.height, null, 0, this.width);
             BufferedImage _img = new BufferedImage(this.width, this.height, BufferedImage.TYPE_INT_ARGB);
@@ -125,11 +123,11 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     }
 
     public String toString() {
-        return String.format("W:%d, H:%d, X:%d, Y:%d | ID:%s, Source:%s", this.width, this.height, this.iconX, this.iconY, this.namespaceId, this.sourceImage);
+        return String.format("W:%d, H:%d, X:%d, Y:%d | ID:%s, Source:%s", this.width, this.height, this.iconX, this.iconY, this.namespaceId, this.sourceImagePath);
     }
 
     public String getImageSource() {
-        return this.sourceImage;
+        return this.sourceImagePath;
     }
 
     @Override
